﻿Type=Class
Version=2.52
@EndOfDesignText@
'long click not working well with continous replacing

Sub Class_Globals
	Private sv As ScrollView
	Private items As List
	Private panels As List
	Private pressedDrawable As Object
	Private EventName As String
	Private CallBack As Object
	Private su As StringUtils
	
	Public dividerHeight As Float
	Public DefaultTextSize, DefaultTextSize2 As Int
	Public DefaultTextColor, DefaultTextColor2 As Int
	Public DividerColor As Int
	Public DefaultTextBackgroundColor As Int
	Public TextFontType, TextFont2Type As Typeface
	
	Public Tag As String
	Public TagPath As String
	
	Public BitmapSize As Int
	Private h1, h2 As Int			'used in conjunction with BitmapSize

End Sub


Public Sub Initialize (vCallback As Object, vEventName As String)
	sv.Initialize2(0, "sv")
	
	items.Initialize
	panels.Initialize
		
	EventName = vEventName
	CallBack = vCallback

	Dim r As Reflector
    r.Target = r.GetContext
    r.Target = r.RunMethod("getResources")
	Dim idPressed As Int
   	idPressed = r.GetStaticField("android.R$drawable", "list_selector_background")
	pressedDrawable = r.RunMethod2("getDrawable", idPressed, "java.lang.int")
	
	sv.Color = 0xFFD9D7DE 'this sets the dividers color
	DividerColor = 0xFFD9D7DE 'this sets the dividers color
	
	DefaultTextColor = Colors.White
	DefaultTextColor2 = Colors.Gray
	DefaultTextBackgroundColor = Colors.Black
	
	DefaultTextSize = 24
	DefaultTextSize2 = 20

	TextFontType = Typeface.DEFAULT
	TextFont2Type = Typeface.DEFAULT
	

	BitmapSize = 46dip
	dividerHeight = 2dip
	
	h1 = ((BitmapSize + 5dip)/2): h2 = h1 + h1
	

End Sub
' Resizes the given picture
Private Sub CreateScaledBitmap(Original As Bitmap, Width As Int, Height As Int) As Bitmap
	Dim r As Reflector
	Dim b As Bitmap
	b = r.RunStaticMethod("android.graphics.Bitmap", "createScaledBitmap", _
			Array As Object(Original, Width, Height, True), _
			Array As String("android.graphics.Bitmap", "java.lang.int", "java.lang.int", "java.lang.boolean"))
	Return b
End Sub

' Resizes the bitmap to fit the given dimensions
Private Sub AdjustBitmap(bmp As Bitmap, Width As Int, Height As Int) As Bitmap
	Dim RatioBmp, RatioIV As Float
	RatioBmp = bmp.Width / bmp.Height
	RatioIV = Width / Height
	Dim Diviseur As Float
	If RatioIV > RatioBmp Then
		Diviseur = bmp.Height / Height
		bmp = CreateScaledBitmap(bmp, Round(bmp.Width / Diviseur / Density), Round(Height / Density))
	Else
		Diviseur = bmp.Width / Width
		bmp = CreateScaledBitmap(bmp, Round(Width / Density), Round(bmp.Height / Diviseur / Density))
	End If
	Return bmp
End Sub

'Clears all items.
Public Sub Clear
	items.Clear
	panels.Clear
	sv.Panel.Height = 0
	For i = sv.Panel.NumberOfViews - 1 To 0 Step -1
		sv.Panel.RemoveViewAt(i)
	Next
End Sub

'Returns a view object that holds the list.
Public Sub AsView As View
	Return sv
End Sub

'Returns the number of items.
Public Sub GetSize As Int
	If items.Size > 0 Then
		If items.Get(items.Size -1) <> "*Mask*" Then
			Return items.Size 
		Else
			Return items.Size -1
		End If
	Else
		Return 0
	End If
End Sub

'Returns the Panel stored at the specified index.
Public Sub GetPanel(Index As Int) As Panel
	Dim p As Panel
	p = panels.Get(Index) 'this is the parent panel
	Return p.GetView(0)
End Sub

'Returns the value stored at the specified index.
Public Sub GetValue(Index As Int) As Object
	Return items.Get(Index)
End Sub

'Removes the item at the specified index.
Public Sub RemoveAt(Index As Int)
	Dim removePanel, p As Panel
	removePanel = panels.Get(Index)
	For i = Index + 1 To items.Size - 1
		p = panels.Get(i)
		p.Tag = i - 1
		p.Top = p.Top - removePanel.Height - dividerHeight
	Next
	
	sv.Panel.Height = sv.Panel.Height - removePanel.Height - dividerHeight
	
	items.RemoveAt(Index)
	panels.RemoveAt(Index)
	removePanel.RemoveView
End Sub

'Adds a text item. The item height will be adjusted based on the text.
Public Sub AddTextItem(Text As String, Text2 As String, Value As Object, Image As Bitmap)
	If items.Size > 0 Then 
		If items.Get(items.Size -1) = "*Mask*" Then
			RemoveAt(items.Size -1)		'remove mask panel
		End If
	End If
	InsertAtTextItem(items.Size, Text, Text2, Value, Image)
End Sub

'Updates a custom item at the specified index.
Public Sub UpdateTextItem(Index As Int, Text As String, Text2 As String, Value As Object, Image As Bitmap)
	If items.Size > 0 Then 
		If items.Get(items.Size -1) = "*Mask*" Then
			RemoveAt(items.Size -1)		'remove mask panel
		End If
	End If
	InsertAtTextItem(Index, Text, Text2, Value, Image)

End Sub

'Inserts a text item at the specified index.
Public Sub InsertAtTextItem(Index As Int, Text As String, Text2 As String, Value As Object, Image As Bitmap)
	h1 = ((BitmapSize + 5dip)/2): h2 = h1 + h1		'DETERMINES THE HEIGHT OF LABEL1 AND LABEL2 BY IMAGE SIZE
	
	Dim pnl As Panel
	pnl.Initialize("")
	
	Dim lbl, lbl2 As Label
	lbl.Initialize("")
	lbl2.Initialize("")
	
	If Image.IsInitialized Then
		'image
		Dim iv As ImageView: iv.Initialize("")
		If NumberFormat(Image.Width / Image.Height, 1, 2) = NumberFormat(1, 1, 2) Then
			' Aspect ratio nearly equal -> filling
			iv.Gravity = Gravity.FILL
		Else
			' Different aspect ratio -> resizing
			Image = AdjustBitmap(Image, BitmapSize, BitmapSize)
			iv.Gravity = Gravity.CENTER_VERTICAL
		End If
		iv.Bitmap = Image
		pnl.AddView(iv, 0, 0, BitmapSize, BitmapSize)
	End If

	lbl.Gravity = Bit.OR(Gravity.CENTER_VERTICAL, Gravity.LEFT)
	lbl2.Gravity = Bit.OR(Gravity.CENTER_VERTICAL, Gravity.LEFT)
	
	Dim sType As Int
	If Text <> "" AND Text2 = "" Then sType = 1
	If Text = "" AND Text2 <> "" Then sType = 2
	If Text <> "" AND Text2 <> "" Then sType = 3
	
	
	'text1
	lbl.Text = Text
	lbl.TextSize = DefaultTextSize
	lbl.TextColor = DefaultTextColor
	lbl.Typeface = TextFontType

	'text2
	lbl2.Text = Text2
	lbl2.TextSize = DefaultTextSize2
	lbl2.TextColor = DefaultTextColor2
	lbl2.Typeface = TextFont2Type
	
	Dim minHeight, minHeight2 As Int

	'WITH IMAGE
	If Image.IsInitialized Then
		Select Case sType
			'FIRST LABEL
			Case 1
				pnl.AddView(lbl, BitmapSize + 5dip, 0, sv.Width - BitmapSize - 5dip, h1)
			'SECOND LABEL
			Case 2
				pnl.AddView(lbl2, BitmapSize + 5dip, 0, sv.Width - BitmapSize - 5dip, h1)
			'BOTH LABELS
			Case 3
				pnl.AddView(lbl, BitmapSize + 5dip, 0, sv.Width - BitmapSize - 5dip, h1)
				minHeight = su.MeasureMultilineTextHeight(lbl, Text)	

				pnl.AddView(lbl2, BitmapSize + 5dip, minHeight, sv.Width - BitmapSize - 5dip, h1)
		End Select
	'WITHOUT IMAGE
	Else
		Select Case sType
			Case 1
				pnl.AddView(lbl, 5dip, 0, sv.Width - 5dip, h1)	
			Case 2
				pnl.AddView(lbl2, 5dip, 0, sv.Width - 5dip, h1)
			Case 3
				pnl.AddView(lbl, 5dip, 0, sv.Width - 5dip, h1)
				minHeight = su.MeasureMultilineTextHeight(lbl, Text)	

				pnl.AddView(lbl2, 5dip, minHeight, sv.Width - 5dip, h1)
		End Select
	End If
	
	pnl.Color = DefaultTextBackgroundColor
			
	'GET HEIGHT OF LABEL
	If Text <> "" Then 
		minHeight = su.MeasureMultilineTextHeight(lbl, Text)
	End If
	
	If Text2 <> "" Then
		minHeight2 = su.MeasureMultilineTextHeight(lbl2, Text2)
	End If
	
	'GET HIGHEST HEIGHT.  H2 IS PREDEFINED ABOVE IN GLOBALS
	Select Case sType
		Case 1: lbl.Height = Max(h2, minHeight): lbl.Top = 3dip
		Case 2: lbl2.Height = Max(h2, minHeight2): lbl2.Top = 3dip
		Case 3:
			lbl.Height = Max(h1, minHeight)
			lbl2.Height = Max(h1, minHeight2)
			lbl.Top = 3dip
			lbl2.Top = lbl.Top + lbl.Height			'SET RIGHT BELOW THE LABEL 1
	End Select
	
	If Image.IsInitialized Then 
		Select Case sType
			Case 1: iv.Top = ((lbl.Height - iv.Height) + 6dip) /2
			Case 2: iv.Top = ((lbl2.Height - iv.Height) + 6dip) /2
			Case 3: iv.Top = ((lbl.Height + lbl2.Height) - iv.Height + 6dip) /2
		End Select
	End If
	
	Select Case sType 
		Case 1:	InsertAt(Index, pnl, lbl.Height + 6dip, 0, Value)
		Case 2: InsertAt(Index, pnl, 0, lbl2.Height + 6dip, Value)
		Case 3:InsertAt(Index, pnl, lbl.Height, lbl2.Height + 6dip, Value)
	End Select

End Sub
'Adds a custom item at the specified index.
Public Sub InsertAt(Index As Int, Pnl As Panel, ItemHeight As Int, ItemHeight2 As Int, Value As Object)
    
	Dim sd As StateListDrawable
    sd.Initialize
    sd.AddState(sd.State_Pressed, pressedDrawable)
    sd.AddCatchAllState(Pnl.Background)
	
	'create another panel to handle the click event
	Dim p As Panel
	p.Initialize("panel")
	p.Background = sd
	
	Dim cd As ColorDrawable
	cd.Initialize(Colors.Transparent, 0)
	
    Pnl.Background = cd
	p.AddView(Pnl, 0, 0, sv.Width, ItemHeight + ItemHeight2)
	p.Tag = Index
	
	'LAST PANEL
	If Index = items.Size Then
		items.Add(Value)
		panels.Add(p)
		Dim Top As Int
		
		If Index = 0 Then 
			Top = dividerHeight 
		Else 
			Top = sv.Panel.Height
		End If
		
		sv.Panel.AddView(p, 0, Top, sv.Width, ItemHeight + ItemHeight2)
	'ANY PANELS BEFORE LAST
	Else
		Dim Top As Int
		If Index = 0 Then
			Top = dividerHeight
		Else
			Dim previousPanel As Panel
			previousPanel = panels.Get(Index - 1)
			Top = previousPanel.Top + previousPanel.Height + dividerHeight
		End If

		Dim p2 As Panel
		For i = Index To panels.Size - 1
			p2 = panels.Get(i)
			p2.Top = p2.Top + ItemHeight + ItemHeight2 + dividerHeight
			p2.Tag = i + 1
		Next
		items.InsertAt(Index, Value)
		panels.InsertAt(Index, p)
		sv.Panel.AddView(p, 0, Top, sv.Width, ItemHeight + ItemHeight2)
	End If
	
	sv.Panel.Height = sv.Panel.Height + ItemHeight + ItemHeight2 + dividerHeight
	If items.Size = 1 Then sv.Panel.Height = sv.Panel.Height + dividerHeight

	If sv.Panel.Height < sv.Height Then
		InsertMaskPanel(items.Size, "*Mask*")
	End If
End Sub

Private Sub InsertMaskPanel(Index As Int, Value As Object)
	Dim pnl As Panel
	pnl.Initialize("")
	
	Dim lbl As Label
	lbl.Initialize("")

	lbl.Gravity = Bit.OR(Gravity.CENTER_VERTICAL, Gravity.LEFT)
	
	Dim minHeight As Int

	pnl.AddView(lbl, 5dip, sv.Panel.Height + dividerHeight, sv.Width - 5dip, h1)	
	
	pnl.Color = DefaultTextBackgroundColor
	
	If sv.Panel.Height > sv.Height Then
		lbl.Height = 1		'TEST THIS
	Else
		lbl.Height = sv.Height - sv.Panel.Height - dividerHeight
	End If
		
	InsertAtMask(Index, pnl, lbl.Height, Value)
End Sub
'Adds a mask panel at the last index.
Private Sub InsertAtMask(Index As Int, Pnl As Panel, ItemHeight As Int, Value As Object)
    
'	Dim sd As StateListDrawable
'    sd.Initialize
'    sd.AddState(sd.State_Pressed, pressedDrawable)
'    sd.AddCatchAllState(Pnl.Background)
	
	'create another panel to handle the click event
	Dim p As Panel
	p.Initialize("panel")
	'p.Background = sd
	
	Dim cd As ColorDrawable
	cd.Initialize(DefaultTextBackgroundColor, 0)
    Pnl.Background = cd
	
	p.AddView(Pnl, 0, 0, sv.Width, ItemHeight)
	p.Tag = Index
	
	'LAST PANEL
	If Index = items.Size Then
		items.Add(Value)
		panels.Add(p)
		Dim Top As Int
		
		If Index = 0 Then 
			Top = dividerHeight 		'FIRST PANEL 
		Else 
			Top = sv.Panel.Height 		'AFTER FIRST PANEL
		End If
		
		sv.Panel.AddView(p, 0, Top, sv.Width, ItemHeight)			'ADD TO SV PANEL
	'ANY PANEL BEFORE LAST.  REMOVE THIS SINCE THIS IS MASK AND LAST PANEL????
	Else
		Dim Top As Int
		If Index = 0 Then
			Top = dividerHeight
		Else
			Dim previousPanel As Panel
			previousPanel = panels.Get(Index - 1)
			Top = previousPanel.Top + previousPanel.Height + dividerHeight
		End If

		Dim p2 As Panel
		For i = Index To panels.Size - 1
			p2 = panels.Get(i)
			p2.Top = p2.Top + ItemHeight + dividerHeight
			p2.Tag = i + 1
		Next
		items.InsertAt(Index, Value)
		panels.InsertAt(Index, p)
		sv.Panel.AddView(p, 0, Top, sv.Width, ItemHeight)
	End If
	
	sv.Panel.Height = sv.Panel.Height + ItemHeight + dividerHeight				
	If items.Size = 1 Then sv.Panel.Height = sv.Panel.Height + dividerHeight
	
End Sub

'Adds a custom item.
Public Sub Add(Pnl As Panel, ItemHeight As Int,  ItemHeight2 As Int, Value As Object)
	InsertAt(items.Size, Pnl, ItemHeight, ItemHeight2, Value)
End Sub

'Scrolls the list to the specified item.
Public Sub JumpToItem(Index As Int)
	Dim Top As Int
	Dim p As Panel
	For i = 0 To Min(Index - 1, items.Size - 1)
		p = panels.Get(i)
		Top = Top + p.Height + dividerHeight
	Next
	sv.ScrollPosition = Top
	'The scroll position doesn't always gets updated without two calls to DoEvents
	DoEvents
	sv.ScrollPosition = Top
	DoEvents
End Sub

Private Sub Panel_Click 
	If SubExists(CallBack, EventName & "_ItemClick") Then
		Dim v As View
		v = Sender
		CallSub3(CallBack, EventName & "_ItemClick", v.Tag, items.Get(v.Tag))
	End If
End Sub
Private Sub Panel_LongClick
	If SubExists(CallBack, EventName & "_LongClick") Then
		Dim v As View
		v = Sender
		CallSub3(CallBack, EventName & "_LongClick", v.Tag, items.Get(v.Tag))
	End If
End Sub

'Returns the index of the item that holds the given view.
Public Sub GetItemFromView(v As View)
	Dim r As Reflector
	Dim parent, current As Object
	parent = v
	Do While (parent Is Panel) = False OR sv.Panel <> parent
		current = parent
		r.Target = current
		parent = r.RunMethod("getParent")
	Loop
	v = current
	Return v.Tag
End Sub
'First line font size
Public Sub SetTextFontSize(Size As Int)
	DefaultTextSize = Size
End Sub
'Second line font size
Public Sub SetText2FontSize(Size As Int)
	DefaultTextSize2 = Size
End Sub
'First line font color
Public Sub SetTextFontColor(Color As Int)
	DefaultTextColor = Color
End Sub
'Second line font color
Public Sub SetText2FontColor(Color As Int)
	DefaultTextColor2 = Color
End Sub
'Text background color
Public Sub SetTextBackgroundColor(Color As Int)
	DefaultTextBackgroundColor = Color
End Sub
'Divider color
Public Sub SetDividerColor(Color As Int)
	sv.Color = Color
	DividerColor = Color
End Sub
'First Line Font Type
Public Sub SetTextFont(FontType As Typeface)
	TextFontType = FontType
End Sub
'Second Line Font Type
Public Sub SetText2Font(FontType As Typeface)
	TextFont2Type = FontType
End Sub
'Divider height (0 to 40)
Public Sub SetDividerHeight(Val As Int)
	Select Case Val
		Case 0: dividerHeight = 0dip
		Case 1: dividerHeight = 1dip
		Case 2: dividerHeight = 2dip
		Case 3: dividerHeight = 3dip
		Case 4: dividerHeight = 4dip
		Case 5: dividerHeight = 5dip
		Case 6: dividerHeight = 6dip
		Case 7: dividerHeight = 7dip
		Case 8: dividerHeight = 8dip
		Case 9: dividerHeight = 9dip
		Case 10: dividerHeight = 10dip
		Case 11: dividerHeight = 11dip
		Case 12: dividerHeight = 12dip
		Case 13: dividerHeight = 13dip
		Case 14: dividerHeight = 14dip
		Case 15: dividerHeight = 15dip
		Case 16: dividerHeight = 16dip
		Case 17: dividerHeight = 17dip
		Case 18: dividerHeight = 18dip
		Case 19: dividerHeight = 19dip
		Case 20: dividerHeight = 20dip
		Case 21: dividerHeight = 21dip
		Case 22: dividerHeight = 22dip
		Case 23: dividerHeight = 23dip
		Case 24: dividerHeight = 24dip
		Case 25: dividerHeight = 25dip
		Case 26: dividerHeight = 26dip
		Case 27: dividerHeight = 27dip
		Case 28: dividerHeight = 28dip
		Case 29: dividerHeight = 29dip
		Case 30: dividerHeight = 30dip
		Case 31: dividerHeight = 31dip
		Case 32: dividerHeight = 32dip
		Case 33: dividerHeight = 33dip
		Case 34: dividerHeight = 34dip
		Case 35: dividerHeight = 35dip
		Case 36: dividerHeight = 36dip
		Case 37: dividerHeight = 37dip
		Case 38: dividerHeight = 38dip
		Case 39: dividerHeight = 39dip
		Case 40: dividerHeight = 40dip
	
	End Select
End Sub
'get the top item index
Public Sub TopItem As Int
	Dim Height, EachPanelHeight, x As Int
	Height = sv.ScrollPosition

	Dim p As Panel
	For i = 0 To items.Size - 1
		p = panels.Get(i)
		EachPanelHeight = EachPanelHeight + p.Height + dividerHeight
		If EachPanelHeight >= Height Then
			Return x
		End If
		x = x + 1
	Next
	
	Return -1
End Sub
'get the bottom item index
Public Sub BottomItem As Int
	Dim Height, EachPanelHeight, x As Int
	Height = sv.ScrollPosition + sv.Height - dividerHeight

	Dim p As Panel
	For i = 0 To items.Size - 1
		p = panels.Get(i)
		EachPanelHeight = EachPanelHeight + p.Height + dividerHeight
		If EachPanelHeight >= Height Then
			If items.Get(items.Size -1) = "*Mask*" Then		'IF MASK THEN REPORT -1
				Return x -1
			Else
				Return x
			End If
		End If
		x = x + 1
	Next
	
	If x > items.Size -1 Then		'THIS OCCURS WHEN YOU FAST SCROLL ALL THE WAY TO THE BOTTOM AND  HEIGHT IS SLIGHTLY HIGHER VALUE AND TOP EVENT WILL NOT RETURN ANYTHING
		If items.Get(items.Size -1) = "*Mask*" Then		'IF MASK THEN REPORT -1
			Return x -2
		Else
			Return x -1
		End If
	Else
		Return -1
	End If
End Sub
